// Duplicator by Randy and Ephialtes, with help from Trader

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$Duplicator::PrefsSet)
	{
		if(!$RTB::RTBR_ServerControl_Hook)
		{
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		}
		RTB_registerPref("Admin Only", "Duplicator", "Pref::Duplicator::AdminOnly", "bool", "Tool_Duplicator", 0, 0, 0);
		RTB_registerPref("Max Bricks (Admin)", "Duplicator", "Pref::Duplicator::MaxBricks::Admin", "int 0 50000", "Tool_Duplicator", 5000, 0, 0);
		RTB_registerPref("Max Bricks (Non-Admin)", "Duplicator", "Pref::Duplicator::MaxBricks::NonAdmin", "int 0 50000", "Tool_Duplicator", 500, 0, 0);
		RTB_registerPref("Selecting Timeout (Admin)", "Duplicator", "Pref::Duplicator::TimeoutA::Admin", "int 0 60", "Tool_Duplicator", 0, 0, 0);
		RTB_registerPref("Selecting Timeout (Non-Admin)", "Duplicator", "Pref::Duplicator::TimeoutA::NonAdmin", "int 0 60", "Tool_Duplicator", 20, 0, 0);
		RTB_registerPref("Planting Timeout (Admin)", "Duplicator", "Pref::Duplicator::TimeoutB::Admin", "int 0 60", "Tool_Duplicator", 0, 0, 0);
		RTB_registerPref("Planting Timeout (Non-Admin)", "Duplicator", "Pref::Duplicator::TimeoutB::NonAdmin", "int 0 60", "Tool_Duplicator", 20, 0, 0);
		RTB_registerPref("Save/Load Timeout (Admin)", "Duplicator", "Pref::Duplicator::TimeoutC::Admin", "int 0 60", "Tool_Duplicator", 0, 0, 0);
		RTB_registerPref("Save/Load Timeout (Non-Admin)", "Duplicator", "Pref::Duplicator::TimeoutC::NonAdmin", "int 0 60", "Tool_Duplicator", 20, 0, 0);
		RTB_registerPref("Rotate Special Properties", "Duplicator", "Pref::Duplicator::RotateSpecial", "bool", "Tool_Duplicator", 1, 0, 0);
		RTB_registerPref("Saving/Loading", "Duplicator", "Pref::Duplicator::SaveLoad", "bool", "Tool_Duplicator", 1, 0, 0);
		RTB_registerPref("Trust Required", "Duplicator", "Pref::Duplicator::Trust", "list None " @ $TrustLevel::None @ " Build " @ $TrustLevel::Build @ " Full " @ $TrustLevel::Full @ " You " @ $TrustLevel::You, "Tool_Duplicator", 2, 0, 0);
		RTB_registerPref("Undo Mode", "Duplicator", "Pref::Duplicator::UndoMode", "list None 0 Single 1 All 2", "Tool_Duplicator", 2, 0, 0);
		RTB_registerPref("Obey 'Too Far' Limit", "Duplicator", "Pref::Duplicator::TooFar", "bool", "Tool_Duplicator", 0, 0, 0);
		RTB_registerPref("Item", "Duplicator", "Pref::Duplicator::Item", "bool", "Tool_Duplicator", 1, 1, 0);
		$Duplicator::PrefsSet = 1;
	}
}
else
{
	// If you do not have RTB you can change the preferences here
	$Pref::Duplicator::AdminOnly           = 0;	// Can only admins use the duplicator? (0 - No, 1 - Yes)
	$Pref::Duplicator::MaxBricks::Admin    = 5000;	// Max bricks selectable by an admin with the duplicator.
	$Pref::Duplicator::MaxBricks::NonAdmin = 500;	// Max bricks selectable by a non-admin with the duplicator.
	$Pref::Duplicator::TimeoutA::Admin     = 0;	// Amount of seconds before an admin can select some bricks again.
	$Pref::Duplicator::TimeoutA::NonAdmin  = 20;	// Amount of seconds before a non-admin can select some bricks again.
	$Pref::Duplicator::TimeoutB::Admin     = 0;	// Amount of seconds before an admin can duplicate again.
	$Pref::Duplicator::TimeoutB::NonAdmin  = 20;	// Amount of seconds before a non-admin can duplicate again.
	$Pref::Duplicator::TimeoutC::Admin     = 0;	// Amount of seconds before an admin can save a duplication again.
	$Pref::Duplicator::TimeoutC::NonAdmin  = 20;	// Amount of seconds before a non-admin can save a duplication again.
	$Pref::Duplicator::RotateSpecial       = 1;	// Rotate special properties relative to bricks? (0 - No, 1 - Yes)
	$Pref::Duplicator::SaveLoad            = 1;	// Enabling saving and loading of duplications? (0 - No, 1 - Yes)
	$Pref::Duplicator::Trust               = 2;	// Trust level requiired to duplicate bricks. (0 - None, 1 - Build, 2 - Full, 3 - You)
	$Pref::Duplicator::UndoMode            = 2;	// What happens when a duplication is undone, (CTRL-Z)? (0 - Nothing, 1 - Bricks deleted one by one, 2 - All bricks deleted)
	$Pref::Duplicator::TooFar              = 0;	// Obey the 'Too Far' limit? (0 - No, 1 - Yes)
	$Pref::Duplicator::Item                = 1;	// Create an item for the duplicator? (0 - No, 1 - Yes)
}

$Duplicator::Msg::AdminOnly  = "<color:FF0000>The duplicator is currently <color:FF8888>admin only<color:FF0000>.";
$Duplicator::Msg::Duplicated = "<color:FF8888>%1<color:FF0000>/<color:FF8888>%2<color:FF0000> duplicated successfully.";
$Duplicator::Msg::MaxBricks  = "<color:FF0000>You have reached the limit of <color:FF8888>%1<color:FF0000> duplicated brick$1.";
$Duplicator::Msg::Timeout    = "<color:FF0000>You cannot %1 anything yet.\nTime remaining: <color:FF8888>%2<color:FF0000> second$2.";
$Duplicator::Msg::Trust      = "<color:FF8888>%1<color:FF0000> does not trust you enough to do that.";
$Duplicator::Msg::Errors     = "<color:FF0000>Planting errors are now <color:FF8888>%1<color:FF0000>.";
$Duplicator::Msg::Exists     = "<color:FF0000>A save file with the name <color:FF8888>%1<color:FF0000> already exists.";
$Duplicator::Msg::Invalid    = "<color:FF0000>Invalid save file name.";
$Duplicator::Msg::NotExist   = "<color:FF0000>The file <color:FF8888>%1<color:FF0000> does not exist.";
$Duplicator::Msg::Saved      = "<color:FF8888>%1<color:FF0000> has been successfully saved.";
$Duplicator::Msg::Loaded     = "<color:FF8888>%1<color:FF0000>/<color:FF8888>%2<color:FF0000> bricks loaded successfully from <color:FF8888>%3<color:FF0000>.";
$Duplicator::Msg::Disabled   = "<color:FF0000>Saving and loading is currently <color:FF8888>disabled<color:FF0000>.";
$Duplicator::Msg::NoDup      = "<color:FF0000>You have not duplicated anything yet.";

$Duplicator::Rotation[0] = "1 0 0 0";
$Duplicator::Rotation[1] = "0 0 1 90";
$Duplicator::Rotation[2] = "0 0 1 180";
$Duplicator::Rotation[3] = "0 0 -1 90";

$Duplicator::Error[0, 1] = 'MsgPlantError_Overlap';
$Duplicator::Error[0, 2] = 'MsgPlantError_Float';
$Duplicator::Error[0, 3] = 'MsgPlantError_Stuck';
$Duplicator::Error[0, 4] = 'MsgPlantError_Unstable';
$Duplicator::Error[0, 5] = 'MsgPlantError_Buried';
$Duplicator::Error[0, 6] = 'MsgPlantError_TooFar';
$Duplicator::Error[0, 7] = 'MsgPlantError_TooLoud';
$Duplicator::Error[0, 8] = 'MsgPlantError_Limit';

$Duplicator::Error[1, 1] = "Overlap";
$Duplicator::Error[1, 2] = "Floating";
$Duplicator::Error[1, 3] = "Stuck";
$Duplicator::Error[1, 4] = "Unstable";
$Duplicator::Error[1, 5] = "Buried";
$Duplicator::Error[1, 6] = "Too Far";
$Duplicator::Error[1, 7] = "Too Loud";
$Duplicator::Error[1, 8] = "Brick Limit Exceeded";
$Duplicator::Error[1, 9] = "Trust";

$Duplicator::DirectionName["North"] = 0;
$Duplicator::DirectionName["East"]  = 1;
$Duplicator::DirectionName["South"] = 2;
$Duplicator::DirectionName["West"]  = 3;

$Duplicator::DirectionValue[0] = "North";
$Duplicator::DirectionValue[1] = "East";
$Duplicator::DirectionValue[2] = "South";
$Duplicator::DirectionValue[3] = "West";

if(!$Duplicator::RotateEventsSet)
{
	if($Duplicator::NumRotateEvents $= "")
	{
		$Duplicator::NumRotateEvents = 0;
	}
	$Duplicator::RotateEvent[$Duplicator::NumRotateEvents] = "fireRelay*";
	$Duplicator::NumRotateEvents++;
	$Duplicator::RotateEventsSet = 1;
}

if(isPackage(duplicator))
{
	deactivatePackage(duplicator);
}

package duplicator
{
	function angleId(%id)
	{
		while(%id < 0)
		{
			%id += 4;
		}
		while(%id > 3)
		{
			%id -= 4;
		}
		return %id;
	}

	function clearCurrentQuotaObject2()
	{
		clearCurrentQuotaObject();
	}

	function determineBrightestColor()
	{
		%target = "1 1 1 1";
		for(%i = 0; %i < 64; %i++)
		{
			%colori = getColorIdTable(%i);
			%dist = vectorDist(%colori, %target);
			if(%dist < %best || %best $= "")
			{
				%best = %dist;
				$Duplicator::HighlightColor = %i;
			}
		}
	}

	function dupCheckString(%string)
	{
		%length = strLen(%string);
		if(%length < 3 || %length > 12)
		{
			return 0;
		}
		%allowed = "abcdefghijklmnopqrstuvwxyz0123456789_-";
		for(%i = 0; %i < %length; %i++)
		{
			if(strPos(%allowed, getSubStr(%string, %i, 1)) == -1)
			{
				return 0;
			}
		}
		return 1;
	}

	function duplicatorImage::onFire(%this, %obj, %slot)
	{
		%start = %obj.getEyePoint();
		%rayCast = containerRayCast(%start, vectorAdd(%start, vectorScale(%obj.getEyeVector(), %this.projectile.range)), %this.projectile.mask);
		%brick = firstWord(%rayCast);
		if(!isObject(%brick))
		{
			return;
		}
		%client = %obj.client;
		%projectile = new projectile()
		{
			dataBlock       = %this.projectile;
			initialVelocity = "0 0 0";
			initialPosition = posFromRaycast(%rayCast);
			sourceObject    = %obj;
			sourceSlot      = %slot;
			client          = %client;
		};
		missionCleanup.add(%projectile);
		if(%brick.getClassName() !$= "fxDtsBrick")
		{
			return;
		}
		if($Sim::Time < %client.dupTimeoutA)
		{
			messageClient(%client, 'MsgPlantError_Flood');
			%client.dupMsg($Duplicator::Msg::Timeout, "duplicate", mCeil(%client.dupTimeoutA - $Sim::Time));
			return;
		}
		if(getTrustLevel(%obj, %brick) < $Pref::Duplicator::Trust)
		{
			%client.dupMsg($Duplicator::Msg::Trust, %brick.getGroup().name);
			return;
		}
		if(%client.isAdmin || %client.isSuperAdmin)
		{
			%timeout = $Pref::Duplicator::TimeoutA::Admin;
			%bricks = $Pref::Duplicator::MaxBricks::Admin;
		}
		else
		{
			if($Pref::Duplicator::AdminOnly)
			{
				%client.dupMsg($Duplicator::Msg::AdminOnly);
				return;
			}
			%timeout = $Pref::Duplicator::TimeoutA::NonAdmin;
			%bricks = $Pref::Duplicator::MaxBricks::NonAdmin;
		}
		%dupObj = new scriptObject()
		{
			bricks = 0;
		};
		if($Duplicator::HighlightColor $= "")
		{
			determineBrightestColor();
		}
		%startPos = %brick.getPosition();
		%stackBrick[%brick] = 1;
		%stackList[0] = %brick;
		%stackHead = 1;
		for(%stackTail = 0; %stackTail != %stackHead; %stackTail++)
		{
			%currBrick = %stackList[%stackTail];
			if(getTrustLevel(%obj, %currBrick) < $Pref::Duplicator::Trust)
			{
				continue;
			}
			if(%dupObj.bricks == %bricks)
			{
				messageClient(%client, $Duplicator::Error[0, 8]);
				%client.dupMsg($Duplicator::Msg::MaxBricks, %bricks);
				break;
			}
			%dupObj.brick[%dupObj.bricks] = %currBrick.getDataBlock().uiName @ "\"" SPC vectorSub(%currBrick.getPosition(), %startPos) SPC %currBrick.getAngleId() SPC %currBrick.isBasePlate() SPC %currBrick.getColorId() SPC %currBrick.getPrintName() SPC %currBrick.getColorFxId() SPC %currBrick.getShapeFxId() SPC %currBrick.isRayCasting() SPC %currBrick.isColliding() SPC %currBrick.isRendering();
			%totalData = -1;
			if(isObject(%currBrick.vehicleDataBlock))
			{
				%dupObj.brickData[%dupObj.bricks, %totalData++] = "+-VEHICLE" SPC %currBrick.vehicleDataBlock.uiName @ "\"" SPC %currBrick.reColorVehicle;
			}
			if(isObject(%currBrick.emitter))
			{
				%dupObj.brickData[%dupObj.bricks, %totalData++] = "+-EMITTER" SPC %currBrick.emitter.emitter.uiName @ "\"" SPC %currBrick.emitterDirection;
			}
			if(isObject(%currBrick.light))
			{
				%dupObj.brickData[%dupObj.bricks, %totalData++] = "+-LIGHT" SPC %currBrick.light.dataBlock.uiName @ "\" ";
			}
			if(isObject(%currBrick.item))
			{
				%dupObj.brickData[%dupObj.bricks, %totalData++] = "+-ITEM" SPC %currBrick.item.dataBlock.uiName @ "\"" SPC %currBrick.itemPosition SPC %currBrick.itemDirection SPC %currBrick.itemRespawnTime;
			}
			if(isObject(%currBrick.audioEmitter))
			{
				%dupObj.brickData[%dupObj.bricks, %totalData++] = "+-AUDIOEMITTER" SPC %currBrick.audioEmitter.profile.uiName @ "\" ";
			}
			if(%currBrick.getName() !$= "")
			{
				%dupObj.brickData[%dupObj.bricks, %totalData++] = "+-NTOBJECTNAME" SPC %currBrick.getName();
			}
			for(%i = 0; %i < %currBrick.numEvents; %i++)
			{
				%dupObj.brickData[%dupObj.bricks, %totalData++] = "+-EVENT" TAB %i TAB %currBrick.eventEnabled[%i] TAB %currBrick.eventInput[%i] TAB %currBrick.eventDelay[%i] TAB %currBrick.eventTarget[%i] TAB %currBrick.eventNT[%i] TAB %currBrick.eventOutput[%i];
				%outputClass = %currBrick.eventTargetIdx[%i] == -1 ? "fxDtsBrick" : inputEvent_GetTargetClass("fxDtsBrick", %currBrick.eventInputIdx[%i], %currBrick.eventTargetIdx[%i]);
				for(%e = 1; %e <= 4; %e++)
				{
					%param = %currBrick.eventOutputParameter[%i, %e];
					if(getWord(getField($OutputEvent_parameterList[%outputClass, %currBrick.eventOutputIdx[%i]], %e - 1), 0) $= "dataBlock" && isObject(%param))
					{
						%param = %param.getName();
					}
					%dupObj.brickData[%dupObj.bricks, %totalData] = %dupObj.brickData[%dupObj.bricks, %totalData] TAB %param;
				}
			}
			%dupObj.bricks++;
			%currBrick.dupHighlight();
			if(%stackTail)
			{
				for(%i = 0; %i < %currBrick.getNumDownBricks(); %i++)
				{
					%newBrick = %currBrick.getDownBrick(%i);
					if(!%stackBrick[%newBrick])
					{
						%stackBrick[%newBrick] = 1;
						%stackList[%stackHead] = %newBrick;
						%stackHead++;
					}
				}
			}
			for(%i = 0; %i < %currBrick.getNumUpBricks(); %i++)
			{
				%newBrick = %currBrick.getUpBrick(%i);
				if(!%stackBrick[%newBrick])
				{
					%stackBrick[%newBrick] = 1;
					%stackList[%stackHead] = %newBrick;
					%stackHead++;
				}
			}
		}
		if(%dupObj.bricks)
		{
			if(isObject(%obj.tempBrick))
			{
				%obj.tempBrick.delete();
			}
			if(isObject(%client.dupObj))
			{
				%client.dupObj.delete();
			}
			%client.dupObj = %dupObj;
			bottomPrint(%client, "<color:FF8888>Duplication<color:FF0000> Mode" NL %dupObj.bricks @ " Brick" @ (%dupObj.bricks == 1 ? "" : "s") @ " Selected", 0, 3);
			%obj.tempBrick = new fxDtsBrick()
			{
				position      = %brick.position;
				rotation      = %brick.rotation;
				dataBlock     = %brick.dataBlock;
				angleId       = %brick.angleId;
				colorId       = %brick.oldColorId;
				printId       = %brick.printId;
				client        = %client;
				dupStartBrick = 1;
			};
			%client.dupTimeoutA = $Sim::Time + %timeout;
		}
		else
		{
			%dupObj.delete();
		}
	}

	function duplicatorImage::onPreFire(%this, %obj, %slot)
	{
		%obj.playThread(2, "armAttack");
	}

	function duplicatorImage::onStopFire(%this, %obj, %slot)
	{
		%obj.playThread(2, "root");
	}

	function fxDtsBrick::dupHighlight(%this)
	{
		if(%this.restoreSchedule $= "")
		{
			%this.oldColorId = %this.colorId;
			%this.oldColorFxId = %this.colorFxId;
			%this.setColor($Duplicator::HighlightColor);
			%this.setColorFx(3);
			%this.restoreSchedule = %this.schedule(2000, "dupRestore");
		}
		else
		{
			cancel(%this.restoreSchedule);
			%this.restoreSchedule = %this.schedule(2000, "dupRestore");
		}
	}

	function fxDtsBrick::dupRestore(%this)
	{
		%this.restoreSchedule = "";
		%this.setColor(%this.oldColorId);
		%this.setColorFx(%this.oldColorFxId);
		%this.oldColorId = "";
		%this.oldColorFxId = "";
	}

	function fxDtsBrick::getPrintName(%this)
	{
		if(%this.getDataBlock().subCategory $= "Prints")
		{
			%texture = getPrintTexture(%this.getPrintId());
			%path = filePath(%texture);
			%underscorePos = strPos(%path, "_");
			%name = getSubStr(%path, %underscorePos + 1, strPos(%path, "_", 14) - 14) @ "/" @ fileBase(%texture);
			if($printNameTable[%name] !$= "")
			{
				return %name;
			}
		}
	}

	function fxDtsBrick::getTooFarDist(%brick, %player)
	{
		%playerPos = %player.getHackPosition();
		%worldBox = %brick.getWorldBox();
		for(%i = 0; %i < 3; %i++)
		{
			%player = getWord(%playerPos, %i);
			%min = getWord(%worldBox, %i);
			%max = getWord(%worldBox, %i + 3);
			if(%player > %max)
			{
				%total += mPow(%player - %max, 2);
			}
			else if(%player < %min)
			{
				%total += mPow(%min - %player, 2);
			}
		}
		return mSqrt(%total);
	}

	function fxDtsBrick::onRemove(%this, %obj)
	{
		if(%this.dupStartBrick && isObject(%this.client))
		{
			bottomPrint(%this.client, "<color:FF8888>Normal<color:FF0000> Mode", 2, 2);
			if(isObject(%this.client.dupObj))
			{
				%this.client.dupObj.delete();
			}
		}
		parent::onRemove(%this, %obj);
	}

	function fxDtsBrick::setColor(%this, %colorId)
	{
		if(%this.restoreSchedule)
		{
			%this.oldColorId = %colorId;
			return;
		}
		if(!%this.dupStartBrick)
		{
			parent::setColor(%this, %colorId);
		}
	}

	function fxDtsBrick::setColorFx(%this, %colorFxId)
	{
		if(%this.restoreSchedule)
		{
			%this.oldColorFxId = %colorFxId;
			return;
		}
		parent::setColorFx(%this, %colorFxId);
	}

	function fxDtsBrick::setDataBlock(%this, %dataBlock)
	{
		if(%this.dupStartBrick && %dataBlock != %this.getDataBlock())
		{
			bottomPrint(%this.client, "<color:FF8888>Normal<color:FF0000> Mode", 2, 2);
			%this.dupStartBrick = "";
			%this.setColor(%this.client.currentColor);
			if(isObject(%this.client.dupObj))
			{
				%this.client.dupObj.delete();
			}
		}
		parent::setDataBlock(%this, %dataBlock);
	}

	function gameConnection::dupMsg(%this, %msg, %param1, %param2, %param3)
	{
		for(%i = 0; %i < (strLen(%msg) - 1); %i++)
		{
			%char = getSubStr(%msg, %i, 1);
			if(%char $= "\\")
			{
				%msg = getSubStr(%msg, 0, %i) @ getSubStr(%msg, %i + 1, strLen(%msg) - %i);
				%i++;
			}
			else if(%char $= "%")
			{
				%firstPart = getSubStr(%msg, 0, %i) @ %param[getSubStr(%msg, %i + 1, 1)];
				%msg = %firstPart @ getSubStr(%msg, %i + 2, strLen(%msg) - %i - 2);
				%i = strLen(%firstPart) - 1;
			}
			else if(%char $= "$")
			{
				%firstPart = getSubStr(%msg, 0, %i) @ (%param[getSubStr(%msg, %i + 1, 1)] == 1 ? "" : "s");
				%msg = %firstPart @ getSubStr(%msg, %i + 2, strLen(%msg) - %i - 2);
				%i = strLen(%firstPart) - 1;
			}
			
		}
		centerPrint(%this, %msg, 2, 2);
	}

	function gameConnection::onClientLeaveGame(%this)
	{
		if(isObject(%this.dupObj))
		{
			%this.dupObj.delete();
		}
		if(isObject(%this.undoObjSet))
		{
			while(isObject(%obj = %this.undoObjSet.getObject(0)))
			{
				%obj.delete();
			}
			%this.undoObjSet.delete();
		}
		parent::onClientLeaveGame(%this);
	}

	function messageClient(%client, %type, %msg, %param0, %param1, %param2, %param3, %param4, %param5, %param6, %param7, %param8, %param9)
	{
		if($Duplicator::TooLoudMsg && %type == $Duplicator::Error[0, 7])
		{
			$Duplicator::TooLoudMsg = 1;
			return;
		}
		return parent::messageClient(%client, %type, %msg, %param0, %param1, %param2, %param3, %param4, %param5, %param6, %param7, %param8, %param9);
	}

	function rotateVector(%vec, %amt)
	{
		if(%amt == 0)
		{
			return %vec;
		}
		else if(%amt == 1)
		{
			return getWord(%vec, 1) SPC -getWord(%vec, 0) SPC getWord(%vec, 2);
		}
		else if(%amt == 2)
		{
			return -getWord(%vec, 0) SPC -getWord(%vec, 1) SPC getWord(%vec, 2);
		}
		else if(%amt == 3)
		{
			return -getWord(%vec, 1) SPC getWord(%vec, 0) SPC getWord(%vec, 2);
		}
	}

	function serverCmdDuplicator(%client)
	{
		if($Pref::Duplicator::AdminOnly && !%client.isAdmin && !%client.isSuperAdmin)
		{
			%client.dupMsg($Duplicator::Msg::AdminOnly);
			return;
		}
		%player = %client.player;
		if(isObject(%player))
		{
			%player.updateArm("duplicatorImage");
			%player.mountImage("duplicatorImage", 0);
		}
	}

	function serverCmdLoadDup(%client, %fileName)
	{
		if(!$Pref::Duplicator::SaveLoad)
		{
			%client.dupMsg($Duplicator::Msg::Disabled);
			return;
		}
		if($Pref::Duplicator::AdminOnly && !%client.isAdmin && !%client.isSuperAdmin)
		{
			%client.dupMsg($Duplicator::Msg::AdminOnly);
			return;
		}
		if($Sim::Time < %client.dupTimeoutC)
		{
			messageClient(%client, 'MsgPlantError_Flood');
			%client.dupMsg($Duplicator::Msg::Timeout, "load", mCeil(%client.dupTimeoutC - $Sim::Time));
			return;
		}
		%fileName = strLwr(%fileName);
		%filePath = "saves/Duplications/" @ %fileName @ ".bls";
		if(!isFile(%filePath))
		{
			%client.dupMsg($Duplicator::Msg::NotExist, %fileName);
			return;
		}
		if(isObject(%client.dupObj))
		{
			%client.dupObj.delete();
		}
		%dupObj = new scriptObject()
		{
			bricks = -1;
		};
		if(%client.isAdmin || %client.isSuperAdmin)
		{
			%timeout = $Pref::Duplicator::TimeoutC::Admin;
			%maxBricks = $Pref::Duplicator::MaxBricks::Admin;
		}
		else
		{
			%timeout = $Pref::Duplicator::TimeoutC::NonAdmin;
			%maxBricks = $Pref::Duplicator::MaxBricks::NonAdmin;
		}
		%fileObj = new fileObject();
		%fileObj.openForRead(%filePath);
		for(%i = 0; %i < 67; %i++)
		{
			%fileObj.readLine();
		}
		%totalBricks = getWord(%fileObj.readLine(), 1);
		while(!%fileObj.isEOF())
		{
			%line = %fileObj.readLine();
			if(getSubStr(%line, 0, 2) $= "+-")
			{
				%dupObj.brickData[%dupObj.bricks, %data++] = %line;
			}
			else
			{
				if(%dupObj.bricks++ == %maxBricks)
				{
					messageClient(%client, $Duplicator::Error[0, 8]);
					break;
				}
				%dupObj.brick[%dupObj.bricks] = %line;
				%data = -1;
			}
		}
		%dupObj.bricks++;
		%fileObj.close();
		%fileObj.delete();
		if(%dupObj.bricks)
		{
			%player = %client.player;
			if(isObject(%player.tempBrick))
			{
				%player.tempBrick.delete();
			}
			%client.dupObj = %dupObj;
			bottomPrint(%client, "<color:FF8888>Duplication<color:FF0000> Mode" NL %dupObj.bricks @ " Brick" @ (%dupObj.bricks == 1 ? "" : "s") @ " Selected", 0, 3);
			%brickStr = %dupObj.brick[0];
			%quotePos = strPos(%brickStr, "\"");
			%dataBlockUiName = getSubStr(%brickStr, 0, %quotePos);
			%brickStr = getSubStr(%brickStr, %quotePos + 2, strLen(%brickStr) - %quotePos - 2);
			%angleId = getWord(%brickStr, 3);
			%player.tempBrick = new fxDtsBrick()
			{
				position      = vectorSub(%player.getHackPosition(), "0 0 1.2");
				rotation      = $Duplicator::Rotation[%angleId];
				dataBlock     = $uiNameTable[%dataBlockUiName];
				angleId       = %angleId;
				colorId       = getWord(%brickStr, 5);
				printId       = $printNameTable[getWord(%brickStr, 6)];
				client        = %client;
				dupStartBrick = 1;
			};
		}
		%client.dupTimeoutC = $Sim::Time + %timeout;
		%client.dupMsg($Duplicator::Msg::Loaded, %dupObj.bricks, %totalBricks, %fileName);
		echo("\c1" @ %client.getPlayerName() @ "\c0 loaded the duplication \c1" @ %fileName @ "\c0.");
	}

	function serverCmdPlantBrick(%client)
	{
		%tempBrick = %client.player.tempBrick;
		if(!%tempBrick.dupStartBrick || !isObject(%client.dupObj))
		{
			parent::serverCmdPlantBrick(%client);
			return;
		}
		if($Pref::Duplicator::AdminOnly && !%client.isAdmin && !%client.isSuperAdmin)
		{
			%tempBrick.dupStartBrick = "";
			%tempBrick.setColor(%client.currentColor);
			bottomPrint(%client, "<color:FF8888>Normal<color:FF0000> Mode", 2, 2);
			parent::serverCmdPlantBrick(%client);
			return;
		}
		if($Sim::Time < %client.dupTimeoutB)
		{
			messageClient(%client, 'MsgPlantError_Flood');
			%client.dupMsg($Duplicator::Msg::Timeout, "plant", mCeil(%client.dupTimeoutB - $Sim::Time));
			return;
		}
		if($Pref::Duplicator::UndoMode == 2)
		{
			%undoObj = new scriptObject()
			{
				bricks = 0;
			};
		}
		for(%i = 0; %i <= 9; %i++)
		{
			%error[%i] = 0;
		}
		%dupObj = %client.dupObj;
		%rotChange = angleId(%tempBrick.angleId - getWord(getSubStr(%dupObj.brick[0], strPos(%dupObj.brick[0], "\"") + 2, strLen(%dupObj.brick[0]) - strPos(%dupObj.brick[0], "\"") - 2), 3));
		%startPos = %tempBrick.getPosition();
		%trustNames = 0;
		%quota = getQuotaObjectFromClient(%client);
		for(%i = 0; %i < mainBrickGroup.getCount(); %i++)
		{
			%totalBricks += mainBrickGroup.getObject(%i).getCount();
		}
		%bricksLeft = $Pref::Server::BrickLimit - %totalBricks;
		for(%i = 0; %i < %dupObj.bricks; %i++)
		{
			if(%error[0] >= %bricksLeft)
			{
				%error[8] += %dupObj.bricks - %i;
				break;
			}
			%brickStr = %dupObj.brick[%i];
			%quotePos = strPos(%brickStr, "\"");
			%dataBlockUiName = getSubStr(%brickStr, 0, %quotePos);
			%brickStr = getSubStr(%brickStr, %quotePos + 2, strLen(%brickStr) - %quotePos - 2);
			%angleId = angleId(getWord(%brickStr, 3) + %rotChange);
			%newBrick = new fxDtsBrick()
			{
				position  = vectorAdd(%startPos, rotateVector(getWords(%brickStr, 0, 2), %rotChange));
				rotation  = $Duplicator::Rotation[%angleId];
				dataBlock = $uiNameTable[%dataBlockUiName];
				angleId   = %angleId;
				colorId   = getWord(%brickStr, 5);
				colorFxId = getWord(%brickStr, 7);
				shapeFxId = getWord(%brickStr, 8);
				isPlanted = 1;
				client    = %client;
			};
			%newBrick.setTrusted(1);
			%err = %newBrick.plant();
			%err = !%err && $Pref::Duplicator::TooFar && %newBrick.getTooFarDist(%client.player) > $Pref::Server::TooFarDistance ? 6 : %err;
			if(%err)
			{
				%newBrick.delete();
			}
			else
			{
				%client.brickGroup.add(%newBrick);
				if(!$Server::LAN)
				{
					for(%d = 0; %d < %newBrick.getNumDownBricks(); %d++)
					{
						%downBrick = %newBrick.getDownBrick(%d);
						if(getTrustLevel(%newBrick, %downBrick) < $TrustLevel::BuildOn)
						{
							%err = 9;
							%found = 0;
							%name = %downBrick.getGroup().name;
							for(%n = 0; %n < %trustNames; %n++)
							{
								if(%trustName[%n] $= %name)
								{
									%found = 1;
									break;
								}
							}
							if(!%found)
							{
								%trustName[%trustNames] = %name;
								%trustNames++;
							}
						}
						else if(!%newBrick.stackBl_Id)
						{
							%newBrick.stackBl_Id = %downBrick.stackBl_Id;
						}
					}
					for(%u = 0; %u < %newBrick.getNumUpBricks(); %u++)
					{
						%upBrick = %newBrick.getUpBrick(%u);
						if(getTrustLevel(%newBrick, %upBrick) < $TrustLevel::BuildOn)
						{
							%err = 9;
							%found = 0;
							%name = %upBrick.getGroup().name;
							for(%n = 0; %n < %trustNames; %n++)
							{
								if(%trustName[%n] $= %name)
								{
									%found = 1;
									break;
								}
							}
							if(!%found)
							{
								%trustName[%trustNames] = %name;
								%trustNames++;
							}
						}
						else if(!%newBrick.stackBl_Id)
						{
							%newBrick.stackBl_Id = %upBrick.stackBl_Id;
						}
					}
					if(!%newBrick.getNumDownBricks() && !%newBrick.getNumUpBricks())
					{
						%newBrick.stackBl_Id = %client.Bl_Id;
					}
				}
				if(%err)
				{
					%newBrick.delete();
				}
				else
				{
					%newBrick.setPrint($printNameTable[getWord(%brickStr, 6)]);
					%newBrick.setRayCasting(getWord(%brickStr, 9));
					%newBrick.setColliding(getWord(%brickStr, 10));
					%newBrick.setRendering(getWord(%brickStr, 11));
					setCurrentQuotaObject(%quota);
					for(%a = 0; (%dataLine = %dupObj.brickData[%i, %a]) !$= ""; %a++)
					{
						if(getField(%dataLine, 0) $= "+-EVENT")
						{
							%eventNum = getField(%dataLine, 1);
							%newBrick.eventEnabled[%eventNum] = getField(%dataLine, 2);
							%newBrick.eventInput[%eventNum] = getField(%dataLine, 3);
							%newBrick.eventInputIdx[%eventNum] = inputEvent_GetInputEventIdx(%newBrick.eventInput[%eventNum]);
							%newBrick.eventDelay[%eventNum] = getField(%dataLine, 4);
							%newBrick.eventTarget[%eventNum] = getField(%dataLine, 5);
							%newBrick.eventTargetIdx[%eventNum] = inputEvent_GetTargetIndex("fxDtsBrick", %newBrick.eventInputIdx[%eventNum], %newBrick.eventTarget[%eventNum]);
							%newBrick.eventNT[%eventNum] = getField(%dataLine, 6);
							%outputClass = %newBrick.eventTargetIdx[%eventNum] == -1 ? "fxDtsBrick" : inputEvent_GetTargetClass("fxDtsBrick", %newBrick.eventInputIdx[%eventNum], %newBrick.eventTargetIdx[%eventNum]);
							%newBrick.eventOutput[%eventNum] = getField(%dataLine, 7);
							%newBrick.eventOutputIdx[%eventNum] = outputEvent_GetOutputEventIdx(%outputClass, %newBrick.eventOutput[%eventNum]);
							%newBrick.eventOutputAppendClient[%eventNum] = $OutputEvent_AppendClient[%outputClass, %newBrick.eventOutputIdx[%eventNum]];
							for(%e = 1; %e <= 4; %e++)
							{
								%eventParamType = getField($OutputEvent_parameterList[%outputClass, %newBrick.eventOutputIdx[%eventNum]], %e - 1);
								if(getWord(%eventParamType, 0) $= "dataBlock" && isObject(getField(%dataLine, %e + 7)))
								{
									%newBrick.eventOutputParameter[%eventNum, %e] = getField(%dataLine, %e + 7).getId();
								}
								else
								{
									%newBrick.eventOutputParameter[%eventNum, %e] = getField(%dataLine, %e + 7);
								}
							}
							if($Pref::Duplicator::RotateSpecial && %rotChange)
							{
								%exit = 0;
								for(%b = 0; %b < $Duplicator::NumRotateEvents && !%exit; %b++)
								{
									%eventName = $Duplicator::RotateEvent[%b];
									%wildCardPos = strPos(%eventName, "*");
									%prefix = getSubStr(%eventName, 0, %wildCardPos);
									%suffix = getSubStr(%eventName, %wildCardPos + 1, strLen(%eventName) - %wildCardPos - 1);
									for(%c = 0; %c < 4; %c++)
									{
										if(%newBrick.eventOutput[%eventNum] $= (%prefix @ $Duplicator::DirectionValue[%c] @ %suffix))
										{
											%newBrick.eventOutput[%eventNum] = %prefix @ $Duplicator::DirectionValue[angleId(%c + %rotChange)] @ %suffix;
											%newBrick.eventOutputIdx[%eventNum] = outputEvent_GetOutputEventIdx(%outputClass, %newBrick.eventOutput[%eventNum]);
											%newBrick.eventOutputAppendClient[%eventNum] = $OutputEvent_AppendClient[%outputClass, %newBrick.eventOutputIdx[%eventNum]];
											%exit = 1;
											break;
										}
									}
								}
								%paramList = $OutputEvent_ParameterList[%outputClass, %newBrick.eventOutputIdx[%eventNum]];
								for(%b = 0; %b < getFieldCount(%paramList); %b++)
								{
									%param = getField(%paramList, %b);
									%type = firstWord(%param);
									if(%type $= "vector")
									{
										%newBrick.eventOutputParameter[%eventNum, %b + 1] = rotateVector(%newBrick.eventOutputParameter[%eventNum, %b + 1], %rotChange);
									}
									else if(%type $= "list")
									{
										for(%c = 1; %c < 4; %c++)
										{
											%dirA[%c] = "";
										}
										for(%c = 1; %c < getWordCount(%param); %c += 2)
										{
											%name = getWord(%param, %c);
											for(%d = 0; %d < 4; %d++)
											{
												if(%name $= $Duplicator::DirectionValue[%d])
												{
													%value = getWord(%param, %c + 1);
													%dirA[%d] = %value;
													%dirB[%value] = %d;
													break;
												}
											}
										}
										if(%dirA[0] $= "" || %dirA[1] $= "" || %dirA[2] $= "" || %dirA[3] $= "")
										{
											continue;
										}
										%angle = %dirB[%newBrick.eventOutputParameter[%eventNum, %b + 1]];
										if(%angle $= "")
										{
											continue;
										}
										%newBrick.eventOutputParameter[%eventNum, %b + 1] = %dirA[angleId(%angle + %rotChange)];
									}
								}
							}
							%newBrick.numEvents++;
							%newBrick.implicitCancelEvents = 0;
							continue;
						}
						%dataLineType = firstWord(%dataLine);
						%dataLineData = restWords(%dataLine);
						if(%dataLineType $= "+-NTOBJECTNAME")
						{
							%ntObjectName = getWord(%dataLineData, 0);
							%newBrick.setNTObjectName(%ntObjectName);
							continue;
						}
						%quotePos = strPos(%dataLineData, "\"");
						%dataLineUiName = getSubStr(%dataLineData, 0, %quotePos);
						%dataLineParams = getSubStr(%dataLineData, %quotePos + 2, strLen(%dataLineData) - %quotePos - 2);
						if(%dataLineType $= "+-VEHICLE")
						{
							%reColorVehicle = getWord(%dataLineParams, 0);
							%newBrick.setReColorVehicle(%reColorVehicle);
							%newBrick.setVehicle($uiNameTable_Vehicle[%dataLineUiName], %client);
						}
						else if(%dataLineType $= "+-EMITTER")
						{
							%emitterDirection = getWord(%dataLineParams, 0);
							if($Pref::Duplicator::RotateSpecial && %emitterDirection > 1)
							{
								%emitterDirection = angleId(%emitterDirection + %rotChange - 2) + 2;
							}
							%newBrick.setEmitterDirection(%emitterDirection);
							%newBrick.setEmitter($uiNameTable_Emitters[%dataLineUiName], %client);
						}
						else if(%dataLineType $= "+-ITEM")
						{
							%itemPosition = getWord(%dataLineParams, 0);
							%itemDirection = getWord(%dataLineParams, 1);
							%itemRespawnTime = getWord(%dataLineParams, 2);
							if($Pref::Duplicator::RotateSpecial)
							{
								if(%itemPosition > 1)
								{
									%itemPosition = angleId(%itemPosition + %rotChange - 2) + 2;
								}
								%itemDirection = angleId(%itemDirection + %rotChange - 2) + 2;
							}
							%newBrick.setItemPosition(%itemPosition);
							%newBrick.setItemDirection(%itemDirection);
							%newBrick.setItemRespawnTime(%itemRespawnTime);
							%newBrick.setItem($uiNameTable_Items[%dataLineUiName]);
						}
						else if(%dataLineType $= "+-LIGHT")
						{
							%newBrick.setLight($uiNameTable_Lights[%dataLineUiName], %client);
						}
						else if(%dataLineType $= "+-AUDIOEMITTER")
						{
							$Duplicator::TooLoudMsg = -1;
							%newBrick.setSound($uiNameTable_Music[%dataLineUiName], %client);
							if($Duplicator::TooLoudMsg == 1)
							{
								%error[7]++;
							}
							$Duplicator::TooLoudMsg = "";
						}
					}
					clearCurrentQuotaObject2();
					if($AddOn__JVS_Content && %newBrick.contentTypeID() > -1)
					{
						%newBrick.noContentEvents = 1;
					}
					if($Pref::Duplicator::UndoMode == 1)
					{
						%client.undoStack.push(%newBrick TAB "PLANT");
					}
					else if($Pref::Duplicator::UndoMode == 2)
					{
						%undoObj.brick[%undoObj.bricks] = %newBrick;
						%undoObj.bricks++;
					}
				}
			}
			%error[%err]++;
		}
		%client.dupMsg($Duplicator::Msg::Duplicated, %error[0], %dupObj.bricks);
		%client.dupTimeoutB = $Sim::Time + (%client.isAdmin || %client.isSuperAdmin ? $Pref::Duplicator::TimeoutB::Admin : $Pref::Duplicator::TimeoutB::NonAdmin);
		if(%client.dupPlantErrors && (%error[0] != %dupObj.bricks || %error[7]))
		{
			for(%i = 1; %i <= 9; %i++)
			{
				if(%error[%i])
				{
					%errors = %errors NL %error[%i] @ " x " @ $Duplicator::Error[1, %i];
				}
			}
			if(%trustNames)
			{
				%nameList = "\n(concerning " @ %trustName0;
				for(%i = 1; %i < %trustNames; %i++)
				{
					%nameList = %nameList @ (%i == (%trustNames - 1) ? " and " : ", ") @ %trustName[%i];
				}
				%nameList = %nameList @ ")";
			}
			commandToClient(%client, 'MessageBoxOK', "Planting Errors", "The following errors occured while planting:" NL %errors @ %nameList);
		}
		if(%error[0] == 0)
		{
			if(isObject(%undoObj))
			{
				%undoObj.delete();
			}
		}
		else
		{
			%client.player.playThread(3, "plant");
			if($Pref::Duplicator::UndoMode == 2)
			{
				if(%error[0] == 1)
				{
					%client.undoStack.push(%undoObj.brick[0] TAB "PLANT");
					%undoObj.delete();
				}
				else
				{
					%client.undoStack.push(%undoObj TAB "MULTIPLANT");
					if(!isObject(%client.undoObjSet))
					{
						%client.undoObjSet = new simSet();
					}
					%client.undoObjSet.add(%undoObj);
				}
			}
		}
	}

	function serverCmdSaveDup(%client, %fileName)
	{
		if(!$Pref::Duplicator::SaveLoad)
		{
			%client.dupMsg($Duplicator::Msg::Disabled);
			return;
		}
		if($Pref::Duplicator::AdminOnly && !%client.isAdmin && !%client.isSuperAdmin)
		{
			%client.dupMsg($Duplicator::Msg::AdminOnly);
			return;
		}
		if(!isObject(%client.dupObj))
		{
			%client.dupMsg($Duplicator::Msg::NoDup);
			return;
		}
		if($Sim::Time < %client.dupTimeoutC)
		{
			messageClient(%client, 'MsgPlantError_Flood');
			%client.dupMsg($Duplicator::Msg::Timeout, "save", mCeil(%client.dupTimeoutC - $Sim::Time));
			return;
		}
		%fileName = strLwr(%fileName);
		if(!dupCheckString(%fileName))
		{
			%client.dupMsg($Duplicator::Msg::Invalid, %fileName);
			return;
		}
		%filePath = "saves/Duplications/" @ %fileName @ ".bls";
		if(isFile(%filePath))
		{
			%client.dupMsg($Duplicator::Msg::Exists, %fileName);
			return;
		}
		%dupObj = %client.dupObj;
		%fileObj = new fileObject();
		%fileObj.openForWrite(%filePath);
		%fileObj.writeLine("This is a Blockland save file.  You probably shouldn't modify it cause you'll screw it up.");
		%fileObj.writeLine("1");
		%fileObj.writeLine("Duplicated by" SPC %client.getPlayerName() @ ".");
		for(%i = 0; %i < 64; %i++)
		{
			%fileObj.writeLine(getColorIdTable(%i));
		}
		%fileObj.writeLine("Linecount" SPC %dupObj.bricks);
		for(%a = 0; %a < %dupObj.bricks; %a++)
		{
			%fileObj.writeLine(%dupObj.brick[%a]);
			for(%b = 0; %dupObj.brickData[%a, %b] !$= ""; %b++)
			{
				%fileObj.writeLine(%dupObj.brickData[%a, %b]);
			}
		}
		%fileObj.close();
		%fileObj.delete();
		%client.dupTimeoutC = $Sim::Time + (%client.isAdmin || %client.isSuperAdmin ? $Pref::Duplicator::TimeoutC::Admin : $Pref::Duplicator::TimeoutC::NonAdmin);
		%client.dupMsg($Duplicator::Msg::Saved, %fileName);
		echo("\c1" @ %client.getPlayerName() @ "\c0 saved the duplication \c1" @ %fileName @ "\c0.");
	}

	function serverCmdToggleDupErrors(%client)
	{
		if($Pref::Duplicator::AdminOnly && !%client.isAdmin && !%client.isSuperAdmin)
		{
			%client.dupMsg($Duplicator::Msg::AdminOnly);
			return;
		}
		%client.dupMsg($Duplicator::Msg::Errors, (%client.dupPlantErrors = !%client.dupPlantErrors) ? "enabled" : "disabled");
	}

	function serverCmdUndoBrick(%client)
	{
		%undoStack = %client.undoStack;
		%undoStr = %undoStack.val[%undoStack.head - 1];
		if(getField(%undoStr, 1) $= "MULTIPLANT")
		{
			%player = %client.player;
			%undoStack.pop();
			%undoObj = getField(%undoStr, 0);
			if(!isObject(%undoObj))
			{
				return;
			}
			for(%i = 0; %i < %undoObj.bricks; %i++)
			{
				%brick = %undoObj.brick[%i];
				if(isObject(%brick))
				{
					for(%d = 0; %d < %brick.getNumDownBricks(); %d++)
					{
						%downBrick = %brick.getDownBrick(%d);
						if(getTrustLevel(%player, %downBrick) < $TrustLevel::UndoBrick)
						{
							%client.dupMsg($Duplicator::Msg::Trust, %downBrick.getGroup().name);
							%undoObj.delete();
							return;
						}
					}
					for(%u = 0; %u < %brick.getNumUpBricks(); %u++)
					{
						%upBrick = %brick.getUpBrick(%u);
						if(getTrustLevel(%player, %upBrick) < $TrustLevel::UndoBrick)
						{
							%client.dupMsg($Duplicator::Msg::Trust, %upBrick.getGroup().name);
							%undoObj.delete();
							return;
						}
					}
				}
			}
			for(%i = 0; %i < %undoObj.bricks; %i++)
			{
				%brick = %undoObj.brick[%i];
				if(isObject(%brick) && !%brick.isDead())
				{
					%brick.killBrick();
					%deleted = 1;
				}
			}
			if(%deleted)
			{
				%client.player.playThread(3, "undo");
			}
			%undoObj.delete();
		}
		else
		{
			parent::serverCmdUndoBrick(%client);
		}
	}
};
activatePackage(duplicator);

datablock particleData(duplicatorExplosionParticle)
{
	colors[0]          = "0.2 1 0.1 0.6";
	colors[1]          = "0.1 1 0.1 0.6";
	colors[2]          = "0.7 1 0.7 0.6";
	colors[3]          = "0.8 1 0.8 0.6";
	dragCoefficient    = 10;
	inheritedVelFactor = 0.2;
	lifetimeMS         = 500;
	lifetimeVarianceMS = 300;
	sizes[0]           = 0.3;
	sizes[1]           = 0.4;
	sizes[2]           = 0.8;
	sizes[3]           = 1.2;
	spinRandomMax      = 90;
	spinRandomMin      = -90;
	textureName        = "base/data/particles/bubble";
	times[1]           = 0.8;
	times[2]           = 1;
};

datablock particleEmitterData(duplicatorExplosionEmitter)
{
	ejectionOffset   = 0.25;
	ejectionPeriodMS = 2;
	ejectionVelocity = 15;
	particles        = "duplicatorExplosionParticle";
	thetaMax         = 120;
	velocityVariance = 5;
};

datablock explosionData(duplicatorExplosion)
{
	camShakeDuration = 0.5;
	camShakeFreq     = "2 2 2";
	emitter[0]       = "duplicatorExplosionEmitter";
	faceViewer       = 1;
	lifetimeMS       = 180;
	lightEndRadius   = 0.5;
	lightStartColor  = "0 1 0 1";
	lightStartRadius = 2.5;
	shakeCamera      = 1;
	soundProfile     = "wandHitSound";
};

datablock particleData(duplicatorParticleA)
{
	colors[0]          = "0.2 1 0.1 0.9";
	colors[1]          = "0.1 1 0.1 0.9";
	colors[2]          = "0.7 1 0.7 0.9";
	colors[3]          = "0.8 1 0.8 0.9";
	gravityCoefficient = -0.5;
	lifetimeMS         = 600;
	lifetimeVarianceMS = 200;
	sizes[0]           = 0.1;
	sizes[1]           = 0.2;
	sizes[2]           = 0.4;
	spinRandomMax      = 90;
	spinRandomMin      = -90;
	textureName        = "base/data/particles/bubble";
	times[1]           = 0.8;
	times[2]           = 1;
};

datablock particleEmitterData(duplicatorEmitterA)
{
	ejectionOffset   = 0.09;
	ejectionPeriodMS = 10;
	ejectionVelocity = 0.2;
	particles        = "duplicatorParticleA";
	periodVarianceMS = 2;
	thetaMax         = 180;
	velocityVariance = 0;
};

datablock particleData(duplicatorParticleB)
{
	colors[0]          = "0.2 1 0.1 0.9";
	colors[1]          = "0.1 1 0.1 0.9";
	colors[2]          = "0.7 1 0.7 0.9";
	colors[3]          = "0.8 1 0.8 0.9";
	gravityCoefficient = -0.2;
	inheritedVelFactor = 0.5;
	lifetimeMS         = 600;
	lifetimeVarianceMS = 200;
	sizes[0]           = 0.1;
	sizes[1]           = 0.2;
	sizes[2]           = 0.4;
	spinRandomMax      = 90;
	spinRandomMin      = -90;
	textureName        = "base/data/particles/bubble";
	times[1]           = 0.8;
	times[2]           = 1;
};

datablock particleEmitterData(duplicatorEmitterB)
{
	ejectionOffset   = 0.1;
	ejectionPeriodMS = 4;
	ejectionVelocity = 0.2;
	particles        = "duplicatorParticleB";
	periodVarianceMS = 2;
	thetaMax         = 180;
	velocityVariance = 0;
};

datablock projectileData(duplicatorProjectile)
{
	bounceElasticity = 0;
	bounceFriction   = 0;
	explodeOnDeath   = 1;
	explosion        = "duplicatorExplosion";
	fadeDelay        = 2;
	gravityMod       = 0;
	lifetime         = 0;
	mask             = $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType;
	range            = 10;
};

datablock shapeBaseImageData(duplicatorImage)
{
	ammo                            = " ";
	armReady                        = "1";
	className                       = "WeaponImage";
	colorShiftColor                 = "0.000000 1.000000 0.000000 1.000000";
	correctMuzzleVector             = "0";
	doColorShift                    = "1";
	doRetraction                    = "0";
	eyeOffset                       = "0.7 1.2 -0.25";
	item                            = "duplicatorItem";
	melee                           = "1";
	projectile                      = "duplicatorProjectile";
	projectileType                  = "Projectile";
	shapeFile                       = "base/data/shapes/wand.dts";
	showBricks                      = "1";
	stateAllowImageChange[2]        = "0";
	stateEmitter[1]                 = "duplicatorEmitterA";
	stateEmitter[3]                 = "duplicatorEmitterB";
	stateEmitterNode[1]             = "muzzlePoint";
	stateEmitterNode[3]             = "blah";
	stateEmitterTime[1]             = "0.15";
	stateEmitterTime[3]             = "0.4";
	stateFire[3]                    = "1";
	stateName[0]                    = "Activate";
	stateName[1]                    = "Ready";
	stateName[2]                    = "PreFire";
	stateName[3]                    = "Fire";
	stateName[4]                    = "CheckFire";
	stateName[5]                    = "StopFire";
	stateScript[2]                  = "onPreFire";
	stateScript[3]                  = "onFire";
	stateScript[5]                  = "onStopFire";
	stateSequence[3]                = "fire";
	stateSequence[5]                = "StopFire";
	stateTimeoutValue[2]            = "0.1";
	stateTimeoutValue[3]            = "0.2";
	stateTimeoutValue[5]            = "0.2";
	stateTransitionOnTimeout[0]     = "ready";
	stateTransitionOnTimeout[1]     = "ready";
	stateTransitionOnTimeout[2]     = "fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTransitionOnTimeout[5]     = "ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateTransitionOnTriggerDown[4] = "fire";
	stateTransitionOnTriggerUp[4]   = "StopFire";
};

if($Pref::Duplicator::Item)
{
	datablock itemData(duplicatorItem)
	{
		cameraMaxDist   = 0.1;
		canDrop         = 1;
		category        = "Weapon";
		className       = "Tool";
		colorShiftColor = "0 1 0 1";
		density         = 0.2;
		doColorShift    = 1;
		elasticity      = 0.2;
		emap            = 1;
		friction        = 0.6;
		iconName        = "base/client/ui/itemIcons/wand";
		image           = "duplicatorImage";
		shapeFile       = "base/data/shapes/wand.dts";
		uiName          = "Duplicator";
	};
}